<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <title>Document</title>
</head>
<body>
    <div class="container">
        <div id="app">
            <h1>{{$store.state.title}}</h1> 
            <form @submit.prevent="submitForm">
                <div id="errorMessage" v-if="$store.state.errors.length>0">
                    <b>Please correct the following errors : </b>
                    <div class="alert alert-danger">
                        <ul>
                            <li v-for="error in $store.state.errors">{{error}}</li>
                        </ul>
                    </div>
                </div>         
                <div class="form-group">                    
                    <label>Nama :</label><br>
                    <input type="text" class="form-control" name="nama" ref="nama" v-model="$store.state.nama" :disabled="$store.state.buttonStatus=='upload'">
                </div>
                <div class="form-group">                    
                    <label>Nomor HP :</label><br>
                    <input type="text" class="form-control" name="noHP" ref="notelepon" v-model="$store.state.notelepon" :disabled="$store.state.buttonStatus=='upload'">
                </div>
                <div class="form-group">                    
                    <label>Alamat :</label><br>
                    <textarea name="alamat" class="form-control" ref="alamat" cols="30" rows="5" v-model="$store.state.alamat" style="resize: none;" :disabled="$store.state.buttonStatus=='upload'"></textarea>
                </div>
                <div v-if="$store.state.buttonStatus == 'submit'">
                    <input type="submit" class="btn btn-success" value="SUBMIT">
                </div>
                <div v-else-if="$store.state.buttonStatus == 'edit'">
                    <input type="button" class="btn btn-warning" @click="updateData" value="EDIT">
                    <input type="button" class="btn btn-secondary" @click="clearForm" value="CANCEL">
                </div>
            </form>
            <table-hasil
                :datausers = "this.dataBlogs" 
                :lokasiphoto = "this.photo"
                @updating="editData($event)"
                @deleting="deleteData($event)">
            </table-hasil>
        </div>
    </div>
    <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
    <script src="https://unpkg.com/vuex@3.5.1/dist/vuex.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>

    <script type="text/template" id="table-user">
        <table width ="100%" class="table table-bordered" style="margin-top: 20px;">
            <tr class="align-middle">
                <td width="20">No</td>
                <td width="250">Nama</td>
                <td width="250">Alamat</td>
                <td width="100">No Hp</td>
                <td width="130">Image</td>
                <td width="250">Aksi</td>
            </tr>
            <tr v-for="(user , index) in dtUsers">
                <td>{{index+1}}</td>
                <td>{{user.name}}</td>
                <td>{{user.address}}</td>
                <td>{{user.no_hp}}</td>
                <td><img :src="user.photo_profile ? $store.state.photo + user.photo_profile : 'https://dummyimage.com/16:9x1080'" width="150"></td>
                <td>
                    <button class="btn btn-sm btn-warning" @click="$emit('updating', user)">Edit</button>
                    <button class="btn btn-sm btn-danger" @click="$emit('deleting', user.id)">Delete</button>
                    <button class="btn btn-sm btn-primary" @click="$emit('uploading', user)">Upload Foto</button>
                </td>
            </tr>
        </table>
    </script>

    <script>
        //VUEX STORE
        const storecontainer = new Vuex.Store({
            state : {
                title : 'Belajar Vue Js',                
                nama : '',
                alamat : '',
                notelepon : '',
                errors : [],
                dataBlogs : [],
                photo :  'http://demo-api-vue.sanbercloud.com/',
                buttonStatus : 'submit',
                idUser : null,
                idPhoto : null
            },
            mutations: {
                getBlogs(state){
                    const config = {
                        method : "get",
                        url : "http://demo-api-vue.sanbercloud.com/api/member"
                    }
                    axios(config)
                        .then ( (response) => {
                            state.dataBlogs=response.data.members
                        })
                        .catch ( (error) => {
                                console.log(error)
                        })
                },
                submitForm(state){
                    if (state.nama.length < 5) {
                        state.errors.push("Nama Minimal 5 Karakter")
                    }
                    if (state.alamat.length < 10) {
                        state.errors.push("Alamat Minimal 10 Karakter")
                    }
                    if (state.notelepon.length < 8) {
                        state.errors.push("Nomor HP minimal 9 Karakter")
                    }
                    if(state.errors.length===0){
                        let dataForm = new FormData()
                        dataForm.append('name',state.nama)
                        dataForm.append('address',state.alamat)
                        dataForm.append('no_hp',state.notelepon)
                        const config = {
                            method : "post",
                            url : "http://demo-api-vue.sanbercloud.com/api/member",
                            data : dataForm
                        }
                        axios(config)
                        .then ( (response) => {    
                            this.commit("getBlogs") 
                            this.commit("clearForm")                   
                            alert(response.data.message)
                        })
                        .catch ( (error) => {
                            console.log(error)
                        })                         
                    } 
                },               
                updateData(state){ 
                    if (state.nama.length < 5) {
                        state.errors.push("Nama Minimal 5 Karakter")
                    }
                    if (state.alamat.length < 10) {
                        state.errors.push("Alamat Minimal 10 Karakter")
                    }
                    if (state.notelepon.length < 8) {
                        state.errors.push("Nomor HP minimal 9 Karakter")
                    }
                    if(state.errors.length===0){                        
                        let formData = new FormData()
                        formData.append('name',state.nama)
                        formData.append('address',state.alamat)
                        formData.append('no_hp',state.notelepon)
                        const config = {
                            method : "post",
                            url : `http://demo-api-vue.sanbercloud.com/api/member/${state.idUser}`,
                            params : { _method : "PUT"},
                            data : formData
                        }
                        axios(config)
                        .then ( (response) => {    
                            this.commit("getBlogs") 
                            this.commit("clearForm")                   
                            alert(response.data.message)
                        })
                        .catch ( (error) => {
                            console.log(error)
                        })                         
                    }       
                },
                deleteData(state){
                    const config = {
                        method : "post",
                        url : `http://demo-api-vue.sanbercloud.com/api/member/${state.idUser}`,
                        params : { _method : "DELETE"}
                        
                    }
                    axios(config)
                        .then ( (response) => {
                            this.commit("getBlogs")
                            alert(response.data.message)
                            
                        })
                        .catch ( (error) => {
                            console.log(error)
                        })
                },                                          
                clearForm(state){
                    state.nama = ''
                    state.alamat = ''
                    state.notelepon = ''
                    state.buttonStatus = 'submit'
                    state.idUser = null
                    state.idPhoto = null
                }
            }
        })
        
        //COMPONENT TABLE
        var tableHasil = {
            template : '#table-user',
            data(){
                return{
                    pesan : 'Header'
                }
            },
            computed: {
                dtUsers(){
                    return this.$store.state.dataBlogs
                }
            },
            props : ['datausers', 'lokasiphoto']
        }
        
        //MAIN VUE
        new Vue({
            el : '#app',
            store : storecontainer,
            components : {
                'table-hasil' : tableHasil
            },
            data : {
                
            },            
            methods:{
                submitForm(){
                    this.$store.commit('submitForm')
                },
                editData(dtblog){
                    console.log(dtblog)
                    this.$store.state.nama=dtblog.name
                    this.$store.state.alamat=dtblog.address
                    this.$store.state.notelepon=dtblog.no_hp
                    this.$store.state.idUser=dtblog.id
                    this.$store.state.buttonStatus='edit'
                },
                clearForm(){
                    this.$store.commit('clearForm')                    
                },
                updateData(){
                    this.$store.commit('updateData')                    
                },
                deleteData(dtUser){
                    this.$store.state.idUser=dtUser
                    this.$store.commit('deleteData') 
                }
            },
            created(){
                this.$store.commit('getBlogs')
            }
        })
    </script>
</body>
</html>